unit hiStrCase;

interface

uses Kol,Share,Debug;

type
  THIStrCase = class(TDebug)
   private
    FResult:string;
   public
    _prop_Type:procedure(var Str:string) of object;

    _data_Str:THI_Event;
    _event_onModify:THI_Event;

    procedure _work_doModify(var _Data:TData; Index:word);
    procedure _var_Result(var _Data:TData; Index:word);
    procedure Lower(var Str:string);
    procedure Upper(var Str:string);
  end;

implementation

procedure THIStrCase._work_doModify;
var
  str:string;
begin
   str := ReadString(_Data,_data_Str,'');
   _prop_Type(str);
   FResult := str;
   _hi_OnEvent(_event_onModify,str);
end;

procedure THIStrCase.Lower;
var i:cardinal;
begin
  if Length(Str) > 0 then
   for i := 1 to Length(Str) do
    if (Str[i] >= 'A')and(Str[i] <= 'Z')or(Str[i] >= '')and(Str[i] <= '')then
      Str[i] := chr(ord(Str[i]) or $20)
    else if Str[i] = '' then
      Str[i] := chr(ord(Str[i]) or $10);
end;

procedure THIStrCase.Upper;
var i:cardinal;
begin
  if Length(Str) > 0 then
   for i := 1 to Length(Str) do
    if (Str[i] >= 'a')and(Str[i] <= 'z')or(Str[i] >= '')and(Str[i] <= '')then
      Str[i] := char( ord(Str[i]) and not $20 )
    else if Str[i] = '' then
      Str[i] := char( ord(Str[i]) and not $10 );
end;

procedure THIStrCase._var_Result;
begin
   _Data.data_type:=data_str;
   _Data.sdata:=FResult;
end;

end.
