unit hiStrPart;

interface

uses Kol,Share,Debug;

type
  THIStrPart = class(TDebug)
   private
    FLeft:string;
    FRight:string;
   public
    _prop_Char:string;

    _data_Str:THI_Event;
    _event_onPart:THI_Event;
    _event_onSplit:THI_Event;
    _event_onNotFound:THI_Event;

    procedure _work_doSplit(var _Data:TData; Index:word);
    procedure _var_Left(var _Data:TData; Index:word);
    procedure _var_Right(var _Data:TData; Index:word);
  end;

implementation

procedure THIStrPart._work_doSplit;
var str:string;
begin
  str := ReadString(_Data,_data_Str,'');

  if (_prop_Char = '') then

  else
   if (pos(_prop_Char[1],str) = 0) then
      _hi_OnEvent(_event_onNotFound,str)
   else if(str <> '') then
    begin
      //debug(str);
      FLeft := GetTok(str,_prop_Char[1]);
      FRight := str;
      _hi_OnEvent(_event_onPart,FLeft);
      _hi_OnEvent(_event_onSplit,str);
    end;
end;

procedure THIStrPart._var_Left(var _Data:TData; Index:word);
begin
  _Data := _DoData(FLeft)
end;

procedure THIStrPart._var_Right(var _Data:TData; Index:word);
begin
  _Data := _DoData(FRight)
end;

end.
