unit hiFormatStr;

interface

uses Kol,Share,Debug;

type
  THIFormatStr = class(TDebug)
   private
    FString:string;
    FDataCount:integer;
    procedure SetCount(Value:integer);
   public
    Str:array of THI_Event;
    _prop_Mask:string;
    _prop_Mode:byte;

    _event_onFString:THI_Event;

    procedure _work_doString(var _Data:TData; Index:word);
    procedure _work_doMask(var _Data:TData; Index:word);
    procedure _var_String(var _Data:TData; Index:word);
    property _prop_DataCount:integer write SetCount;
  end;

implementation

procedure THIFormatStr.SetCount;
begin
   SetLength(Str,Value);
   FDataCount := Value;
end;

procedure THIFormatStr._work_doString;
var
  i:word;
  s,s1:string;
  pos,start:integer;
begin
  s := _prop_Mask;
  if FDataCount > 0 then begin
    pos := 1;
    while pos < Length(s) do
      if s[pos] = '%' then begin
        start := pos;
        inc(pos);
        if s[pos] = '%' then delete(s,start,1)
        else begin
          i := 0;
          while (pos <= Length(s))and(s[pos] in ['0'..'9']) do begin
            i:=i*10+ord(s[pos])-$30;
            inc(pos);
          end;
          if (i>0)and(i<=FDataCount) then begin
            delete(s,start,pos - start);
            s1:=ReadString(_Data,Str[i-1],'');
            insert(s1,s,start);
            pos:=start;
            if _prop_Mode=1 then inc(pos,Length(s1));
          end;
        end;
      end
      else inc(pos);
  end;
  FString := s;
  _hi_OnEvent(_event_onFString,s);
end;

procedure THIFormatStr._work_doMask(var _Data:TData; Index:word);
begin
   _prop_Mask := ToString(_Data);
end;

procedure THIFormatStr._var_String;
begin
   _Data.Data_type := data_str;
   _Data.sdata := FString;
end;

end.
